/*================================================================================================*
 * Интерфейс с ядром M0 (через переменные volatile)
 *================================================================================================*/

#ifndef M0_TASK_H_
#define M0_TASK_H_

#include "global.h"
#include "settings.h"

/*================================================================================================*/
#define _M0_CODE_               __attribute__ ((section(".text_m0")))
#define _M0_DATA_I_             __attribute__ ((section(".data_m0")))
#define _M0_DATA_Z_             __attribute__ ((section(".bss_m0")))
/*================================================================================================*/

/*================================================================================================*/
/* Константы для интервалов посылки */
#define M0_PERIOD_NS(n)         CYCLES_NS_NLESS(LPC_CLK_MCPWM, (n))
#define M0_TX_INTERVAL_FAST     (M0_PERIOD_NS(SET_SSP_OUT_TBYTE_FAST_NS) - 1)
#define M0_TX_INTERVAL_SLOW     (M0_PERIOD_NS(SET_SSP_OUT_TBYTE_SLOW_NS) - 1)

/* Размер буфера передатчика в 16-битных словах */
#define M0_TX_BUF_LEN           4096

#if M0_TX_BUF_LEN & (M0_TX_BUF_LEN - 1)
#error "M0_TX_BUF_LEN should be a power of 2"
#endif
/*================================================================================================*/

/*================================================================================================*/
/* Интервал посылки в тиках таймера */
extern _M0_DATA_Z_ volatile uint32_t g_m0_tx_interval;  

/* Буфер передатчика */
extern _M0_DATA_Z_ volatile uint16_t g_m0_tx_buf[M0_TX_BUF_LEN];
extern _M0_DATA_Z_ volatile size_t g_m0_tx_head, g_m0_tx_tail;
/*================================================================================================*/

/*================================================================================================*/
/* ФУНКЦИИ ЗДЕСЬ ТОЛЬКО INLINE, потому что m0_task.c компилируется для другого ядра! */
/*------------------------------------------------------------------------------------------------*/
static inline void m0_core_start(void)
    {
    extern uint32_t _text_m0;
    LPC_CREG->M0APPMEMMAP = (uint32_t)&_text_m0;
    LPC_RGU->RESET_CTRL1 = ~LPC_RGU->RESET_ACTIVE_STATUS1 & ~(1UL << (RGU_M0APP_RST - 32));
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
static inline void m0_core_stop(void)
    {
    LPC_RGU->RESET_CTRL1 = ~LPC_RGU->RESET_ACTIVE_STATUS1 | (1UL << (RGU_M0APP_RST - 32));
    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
#endif /* M0_TASK_H_ */
